<template>
  <div class="video-js" ref="videos" style="width: 100%; height: 100%"></div>
</template>

<script>
import videojs from 'video.js'
import 'videojs-contrib-hls'
import 'video.js/dist/video-js.css'
export default {
  props: {
    url: {
      type: String,
      default: '',
    },
    id: {
      type: String,
      default: 'videoRefI',
    },
  },
  data() {
    return {
      player: null,
    }
  },
  mounted() {
    this.initVideo()
  },
  beforeDestroy() {
    this.player?.dispose()
  },
  methods: {
    initVideo() {
      let video = document.createElement('video')
      video.id = this.id
      video.style = 'width: 100%; height: 100%;object-fit:cover;'
      video.controls = true
      video.preload = 'auto'
      video.setAttribute('x5-playsinline', 'true')
      video.setAttribute('x-webkit-airplay', 'allow')
      video.setAttribute('playsinline', true) //IOS微信浏览器支持小窗内播放
      video.setAttribute('webkit-playsinline', true) //这个bai属性是ios 10中设置可以让视频在小du窗内播放，也就是不是全zhi屏播放的video标签的一个属性
      video.setAttribute('x5-video-player-type', 'h5') //安卓 声明启用同层H5播放器 可以在video上面加东西
      // video.setAttribute('poster', 'https://img.yzcdn.cn/vant/cat.jpeg')
      let source = document.createElement('source')
      source.src = this.url
      video.appendChild(source)
      // return
      this.$refs.videos.appendChild(video)
      let that = this
      let player = videojs(
        this.id,
        {
          playbackRates: [0.7, 1.0, 1.5, 2.0], //播放速度
          autoDisable: true,
          preload: 'none', //auto - 当页面加载后载入整个视频 meta - 当页面加载后只载入元数据 none - 当页面加载后不载入视频
          language: 'zh-CN',
          fluid: true, // 自适应宽高
          muted: true, //  是否静音
          aspectRatio: '16:9', // 将播放器置于流畅模式，并在计算播放器的动态大小时使用该值。值应该代表一个比例 - 用冒号分隔的两个数字（例如"16:9"或"4:3"）
          controls: false, //是否拥有控制条 【默认true】,如果设为false ,那么只能通过api进行控制了。也就是说界面上不会出现任何控制按钮
          autoplay: true, //如果true,浏览器准备好时开始回放。 autoplay: "muted", // //自动播放属性,muted:静音播放
          loop: true, // 导致视频一结束就重新开始。 视频播放结束后，是否循环播放
          screenshot: true,
          controlBar: {
            volumePanel: {
              //声音样式
              inline: false, // 不使用水平方式
            },
            timeDivider: true, // 时间分割线
            durationDisplay: true, // 总时间
            progressControl: true, // 进度条
            remainingTimeDisplay: true, //当前以播放时间
            fullscreenToggle: true, //全屏按钮
            pictureInPictureToggle: true, //画中画
          },
        },
        function () {
          this.on('error', function (err) {
            //请求数据时遇到错误
            console.log('请求数据时遇到错误', err)
          })
          this.on('stalled', function (stalled) {
            //网速失速
            console.log('网速失速', stalled)
          })
        }
      )
    },
  },
}
</script>
<style lang="scss">
// .vjs-loading-spinner {
//   .vjs-control-text {
//     display: none !important;
//   }
// }

.myvideo {
  @apply w-full h-full;

  video {
    @apply w-full h-full;
  }
}
</style>
